=== debian/changelog ===
cccl (2.2.0-3) unstable; urgency=medium

  * Restrict upstream testsuite autopkgtest to amd64 arm64 ppc64el.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 22 Feb 2025 09:05:29 +0100

cccl (2.2.0-2) unstable; urgency=medium

  * Bump Standards-Version to 4.7.1, no changes needed.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 20 Feb 2025 22:11:31 +0100

cccl (2.2.0-1) experimental; urgency=medium

  * New upstream release 2.2.0.
    - Thrust, CUB and libcudacxx have been merged create CCCL, the
      CUDA Core Compute Libraries.
  * Build libcu++-dev, libcub-dev and libthrust-dev from this source.
  * Refresh patches.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 20 Jan 2025 14:03:52 +0100

libthrust (2.1.1-1) unstable; urgency=medium

  * New upstream release 2.1.1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 02 Jul 2024 14:15:03 +0200

libthrust (2.1.0-1) unstable; urgency=medium

  * New upstream release 2.1.0.  (Closes: #1074279)
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 26 Jun 2024 00:09:14 +0200

libthrust (2.0.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 15 Jun 2023 10:31:22 +0200

libthrust (2.0.1-1) experimental; urgency=medium

  * New upstream release 2.0.1.
  * Add (Build-)Depends: libcu++-dev (>= 1.8.0).
  * Fix autopkgtests with older nvcc.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 17 Mar 2023 16:53:41 +0100

libthrust (1.17.2-2) unstable; urgency=medium

  * Stop testing with g++-10.
  * Bump Standards-Version to 4.6.2, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 21 Feb 2023 11:44:15 +0100

libthrust (1.17.2-1) unstable; urgency=medium

  * New upstream release 1.17.2.
  * Install *.cmake to CMAKE_INSTALL_DATADIR.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 23 Dec 2022 20:56:18 +0100

libthrust (1.16.0-2) unstable; urgency=medium

  * Mark TBB/CUDA test as flaky.  (Closes: #1016711)
  * Update watch file.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 11 Nov 2022 12:11:17 +0100

libthrust (1.16.0-1) unstable; urgency=medium

  * New upstream release 1.16.0.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 19 Jun 2022 20:27:00 +0200

libthrust (1.15.0-6) unstable; urgency=medium

  * Disable cuda tests on !amd64, they always run into timeout.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 05 Jun 2022 23:19:51 +0200

libthrust (1.15.0-5) unstable; urgency=medium

  * Avoid using '/' in autopkgtest names.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 02 Jun 2022 03:32:27 +0200

libthrust (1.15.0-4) unstable; urgency=medium

  * Reduce amount of autopkgtest tests.  (Closes: #1011646)

 -- Andreas Beckmann <anbe@debian.org>  Fri, 27 May 2022 06:20:52 +0200

libthrust (1.15.0-3) unstable; urgency=medium

  * Generate debian/tests/control from debian/tests/control.sh.
  * More fine-grained CUDA autopkgtests to avoid timeouts.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 25 May 2022 21:29:40 +0200

libthrust (1.15.0-2) unstable; urgency=medium

  * Add salsa-ci.yml.
  * Tune autopkgtests.
  * Bump Standards-Version to 4.6.1, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 24 May 2022 19:02:05 +0200

libthrust (1.15.0-1) unstable; urgency=medium

  * New upstream release 1.15.0 (CUDA 11.6).
  * Recommend libtbb-dev.
  * Tighten cub dependency.  (Closes: #1006226)
  * Use upstream build system for installation.
  * Add superficial autopkgtest for cmake find_package(Thrust).
  * Add superficial autopkgtest running (CPP, TBB, OMP) or compiling (CUDA)
    the upstream testsuite for C++14 and C++17 (requires
    nvidia-cuda-toolkit/non-free).
    (Running the CUDA testsuite would require a CUDA capable CPU and using the
    kernel module from nvidia-graphics-drivers/non-free.)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 01 Mar 2022 20:51:54 +0100

libthrust (1.14.0-1) unstable; urgency=medium

  * New upstream release 1.14.0.
  * New upstream release 1.13.1 (CUDA 11.5).
  * New upstream release 1.13.0.
  * New upstream release 1.12.1 (CUDA 11.4).
  * New upstream release 1.12.0.
  * Bump Standards-Version to 4.6.0, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 26 Sep 2021 22:36:56 +0200

libthrust (1.11.0-1) unstable; urgency=medium

  * New upstream release 1.11.0 (CUDA 11.3).
  * New upstream release 1.10.0 (CUDA 11.2).
  * Update upstream location.
  * Bump Standards-Version to 4.5.1, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 08 Jan 2021 15:11:26 +0100

libthrust (1.9.10-1-1) unstable; urgency=medium

  * New upstream release 1.9.10-1 (CUDA 11.1).
  * cub is a separate project since 1.9.8.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 10 Aug 2020 21:37:56 +0200

libthrust (1.9.7-1-1) unstable; urgency=medium

  * New upstream release 1.9.7-1 (CUDA 10.2 for Tegra).

 -- Andreas Beckmann <anbe@debian.org>  Thu, 09 Jul 2020 18:58:30 +0200

libthrust (1.9.7-1) unstable; urgency=medium

  * New upstream snapshot 1.9.7 (CUDA 10.2).
    (Last commit before removal of the embedded cub.)
  * Switch to debhelper-compat (= 13).
  * Bump Standards-Version to 4.5.0. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 08 Jul 2020 10:54:11 +0200

libthrust (1.9.5-1) unstable; urgency=medium

  * New upstream release 1.9.5 (CUDA 10.1 Update 1).  (Closes: #934455)
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 15 Aug 2019 12:21:42 +0200

libthrust (1.9.4-1) experimental; urgency=medium

  * New upstream release 1.9.4 (CUDA 10.1).  (Closes: #923689)
  * Refresh debian/copyright.
  * Update watch file.
  * Switch to debhelper-compat (= 12).
  * Bump Standards-Version to 4.4.0. No changes needed.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 01 Aug 2019 14:03:17 +0200

libthrust (1.8.2-1) unstable; urgency=medium

  * New upstream release.

