=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

LIT_VERSION	 = $(shell sed -n -r '/^Build/,/^$$/s/.*llvm-([0-9]+)-tools.*/\1/p' debian/control)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLLVM_EXTERNAL_LIT=/usr/lib/llvm-$(LIT_VERSION)/build/utils/lit/lit.py \
		-DLIBCUDACXX_ENABLE_CUDA=OFF \
		-DCUB_ENABLE_HEADER_TESTING=OFF \
		-DCUB_ENABLE_TESTING=OFF \
		-DCUB_ENABLE_EXAMPLES=OFF \
		-DTHRUST_DEVICE_SYSTEM=CPP \
		-DTHRUST_CPP_DIALECT=17 \
		-Wno-dev

execute_after_dh_auto_install:
	# remove empty directories
	find debian/tmp -depth -type d -exec sh -c 'd="{}"; rmdir --ignore-fail-on-non-empty "$$d" ; test -d "$$d" || echo "removed $$d"' \;

override_dh_installexamples:
	dh_installexamples -X.gitignore


debian/tests/control: debian/tests/control.sh
	sh $< > $@

clean: debian/tests/control
