=== debian/tests/control ===
# Generated from debian/tests/control.sh, do not edit manually!

Test-Command: cmake -Wno-dev -B $AUTOPKGTEST_TMP -S debian/tests/cmake/libcudacxx
Features: test-name=cmake_find_package_libcudacxx
Depends:
 libcu++-dev,
 cmake,
 make,
 g++,
Restrictions:
 superficial,

Test-Command: cmake -Wno-dev -B $AUTOPKGTEST_TMP -S debian/tests/cmake/cub
Features: test-name=cmake_find_package_CUB
Depends:
 libcub-dev,
 cmake,
 make,
 g++,
Restrictions:
 superficial,

Test-Command: cmake -Wno-dev -B $AUTOPKGTEST_TMP -S debian/tests/cmake/thrust
Features: test-name=cmake_find_package_Thrust
Depends:
 libthrust-dev,
 cmake,
 make,
 g++,
 libtbb-dev,
Restrictions:
 superficial,

Test-Command: cmake -Wno-dev -B $AUTOPKGTEST_TMP -S debian/tests/cmake/cccl
Features: test-name=cmake_find_package_cccl
Depends:
 libcccl-dev,
 cmake,
 make,
 g++,
Restrictions:
 superficial,

Test-Command: debian/tests/upstream-testsuite-cpp
Features: test-name=upstream-testsuite-cpp
Architecture: amd64 arm64 ppc64el
Depends:
 libcccl-dev,
 cmake,
 make,
 llvm-19-tools,
 python3,
 g++,
Restrictions:
 superficial,
 allow-stderr,

Test-Command: debian/tests/compile-upstream-testsuite-cuda
Features: test-name=compile-upstream-testsuite-cuda
Architecture: amd64
Depends:
 libcccl-dev,
 cmake,
 make,
 llvm-19-tools,
 python3,
 nvidia-cuda-toolkit-gcc,
 git,
Restrictions:
 superficial,
 allow-stderr,
 needs-internet,
 flaky,

Test-Command: debian/tests/upstream-testsuite CPP 17 g++-12
Features: test-name=run_testsuite_CPP_C++17_g++-12
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 g++-12,
Restrictions:
 powerful-cuda-machine,
 superficial,
 allow-stderr,
 flaky,

Test-Command: debian/tests/upstream-testsuite TBB 17
Features: test-name=run_testsuite_TBB_C++17
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 g++,
Restrictions:
 powerful-cuda-machine,
 superficial,
 allow-stderr,
 flaky,

Test-Command: debian/tests/upstream-testsuite CPP/CUDA 17 cuda-g++
Features: test-name=compile_testsuite_CPP_CUDA_C++17_cuda-g++
Architecture: amd64
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 powerful-cuda-machine,
 superficial,
 allow-stderr,

Test-Command: debian/tests/upstream-testsuite TBB/CUDA 17 cuda-g++
Features: test-name=compile_testsuite_TBB_CUDA_C++17_cuda-g++
Architecture: amd64
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 powerful-cuda-machine,
 superficial,
 allow-stderr,
 flaky,
